#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct EnumEqualityRangesNode {
    #[builder(default, list(item(type = super::EnumSeriesNode)))]
    #[serde(rename = "inputs", skip_serializing_if = "Vec::is_empty", default)]
    inputs: Vec<super::EnumSeriesNode>,
    #[serde(rename = "operator")]
    operator: super::super::super::api::EqualityOperator,
    #[builder(custom(type = super::AlignmentConfiguration, convert = Box::new))]
    #[serde(rename = "alignmentConfiguration")]
    alignment_configuration: Box<super::AlignmentConfiguration>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::PersistenceWindowConfiguration>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "persistenceWindowConfiguration",
        skip_serializing_if = "Option::is_none",
        default
    )]
    persistence_window_configuration: Option<Box<super::PersistenceWindowConfiguration>>,
}
impl EnumEqualityRangesNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        operator: super::super::super::api::EqualityOperator,
        alignment_configuration: super::AlignmentConfiguration,
    ) -> Self {
        Self::builder()
            .operator(operator)
            .alignment_configuration(alignment_configuration)
            .build()
    }
    #[inline]
    pub fn inputs(&self) -> &[super::EnumSeriesNode] {
        &*self.inputs
    }
    #[inline]
    pub fn operator(&self) -> &super::super::super::api::EqualityOperator {
        &self.operator
    }
    #[inline]
    pub fn alignment_configuration(&self) -> &super::AlignmentConfiguration {
        &*self.alignment_configuration
    }
    #[inline]
    pub fn persistence_window_configuration(
        &self,
    ) -> Option<&super::PersistenceWindowConfiguration> {
        self.persistence_window_configuration.as_ref().map(|o| &**o)
    }
}
